/*-------------------------------------------------------------------------*/
/* FILENAME: dsk6xHSB.h - HandShakingBuffer Header File                    */
/*                                                                         */
/*  Rev 2.0   17 July 2000  T.J.Dillon                                     */
/*                                                                         */
/*-------------------------------------------------------------------------*/

#define HS_BUFFER_LEN	6
#define ID_0			0x12345678
#define ID_1			0xf1f2f3f4
#define ID_2			0x08070605
// 4th is the command
#define ISRAM	0x1000
#define SDRAM	0x2000
#define FLASH	0x3000
#define MCBSP	0x4000
#define TIMER	0x5000
#define QDMA	0x6000
#define LEDS	0x7000
#define CODEC 0x8000
#define MENU  0x9000
#define PGMEM 0xA000
// 5th is the status register
#define HOST_RECEIVE_HAND_SHAKING_INFO	0x55555555
#define HOST_STATUS_INPUT_READY			0x77777777
#define HOST_STATUS_END_PROCESSING		0xFFFFFFFF
#define DSP_STATUS_OUTPUT_READY			0x66666666
#define DSP_PROCESSING_COMMAND			0x88888888
// 6th is return error code
#define ISRAM_OK	  0x10000000
#define ISRAM_ERR55 0x10005555
#define ISRAM_ERRAA 0x1000AAAA
#define ISRAM_ERROR 0x1000FFFF
#define SDRAM_OK  	0x20000000
#define SDRAM_ERR55 0x20005555
#define SDRAM_ERRAA 0x2000AAAA
#define SDRAM_ERR5A 0x20005A5A
#define SDRAM_ERRA5 0x2000A5A5
#define SDRAM_ERROR 0x2000FFFF
#define FLASH_OK  	0x30000000
#define FLASH_ERRCK 0x30003333
#define FLASH_ERR55 0x30005555
#define FLASH_ERR77 0x30007777
#define FLASH_ERRAA 0x3000AAAA
#define FLASH_ERRBB 0x3000BBBB
#define FLASH_ERROR 0x3000FFFF
#define MCBSP_OK  	0x40000000
#define MCBSP_ERROR 0x4000FFFF
#define TIMER_OK  	0x50000000
#define TIMER_ERROR 0x5000FFFF
#define QDMA_OK     0x60000000
#define QDMA_ERROR  0x6000FFFF
#define LEDS_OK     0x70000000
#define LEDS_ERROR  0x7000FFFF
#define CODEC_OK    0x80000000
#define CODEC_ERRTN 0x80005555
#define CODEC_ERRCD 0x8000AAAA
#define CODEC_ERROR 0x8000FFFF
#define PGMEM_OK    0xA0000000
#define PGMEM_ERROR 0xA000FFFF
#define TEST_DISABLED 0xFF00FFFF
#define DEFAULT_ERROR 0xF000FFFF

